import org.gicentre.utils.stat.*;
import java.util.*;
import controlP5.*;

ControlP5 cp5;

public class Button {
  String code;
  String text;
  color col;
}

ArrayList<XYChart> lineCharts = new ArrayList<XYChart>(10);
ArrayList<ArrayList<PVector>> graphData = new ArrayList<ArrayList<PVector>>();
int activeChart = 0;
ArrayList<Button> buttons = new ArrayList<Button>();

int graphStartMillis =0;
int maxXDataLength = 50;
String pageTitle = "";
String pageSubtitle = "";

float setMaxY=1;
float setMinY=0;
float setMaxX=1;
float setMinX=0;

void addChartWithSettingsAndData() {
  lineCharts.add(new XYChart(this));
  graphData.add(new ArrayList<PVector>());
  int index = lineCharts.size()-1;
  if (index==0) {
    lineCharts.get(index).showXAxis(true); 
    lineCharts.get(index).showYAxis(true); 
  } else {
    lineCharts.get(index).showXAxis(false); 
    lineCharts.get(index).showYAxis(false);
  }
  lineCharts.get(index).setMinY(setMinY);
  lineCharts.get(index).setMaxY(setMaxY);
  lineCharts.get(index).setMinX(setMinX);
  lineCharts.get(index).setMaxX(setMaxX);
     
//  lineChart.setYFormat("$###,###");  // Monetary value in $US
//  lineChart.setXFormat("0000");      // Year
   
  // Symbol colours
  lineCharts.get(index).setPointColour(color(0));
  lineCharts.get(index).setLineColour(color(255,0,0));
  lineCharts.get(index).setPointSize(5);
  lineCharts.get(index).setLineWidth(2);
}

int bwidth=30;
int bheight=30;
int bxstart = width-190;
int bystart = 50;
int byoffset = 50;
int lxstart = width-150;

PonyPlotLogo pplogo;
static int instance = 0;

void settings() {
  if (instance==0) {
    size(1000,500);
    instance++;
  } else {
    //fullScreen();
    size(500,500);
  }
}

PFont chartfont;

void setup()
{
  frameRate(10);
  surface.setResizable(true);
/*  
  cp5 = new ControlP5(this);
  
  cp5.addScrollableList("dropdown")
     .setPosition(100, 100)
     .setSize(200, 100)
     .setBarHeight(20)
     .setItemHeight(20)
     .addItems(Serial.list())
     .setType(ScrollableList.LIST) // currently supported DROPDOWN and LIST
     ;
*/
  pplogo = new PonyPlotLogo(this);
  chartfont = createFont("Arial",10);
  setup_serial_connection();
  
  addChartWithSettingsAndData();
}



Boolean arduinoStartReceived = false;

void checkArduino() {
  while(arduinoMessageAvailable()) {
    TimeStampedString tts = getArduinoMessage();
    String msg = tts.string;
//    println("From arduino: -->"+msg+"<--");
    if ("0123456789.-".contains(msg.substring(0,1)) ) {
//      println("data >"+msg+"<");
        String[] parts;
        if (msg.contains(" ")) {
          parts = msg.split(" ");
          if (parts.length==2) {
            try {
              PVector v = new PVector(Float.parseFloat(parts[0]),Float.parseFloat(parts[1]));
              if (v.y<=setMaxY && v.y>=setMinY) {
                graphData.get(activeChart).add(v);
                if (maxXDataLength>0) {
                  if (graphData.get(activeChart).size()>maxXDataLength) {
                    graphData.get(activeChart).remove(0);  
                }
              }
            }
          } catch(Exception e) {
            e.printStackTrace();
          }
          }
        } else 
        if (msg.contains("\t")) {
          parts = msg.split("\t");
        } else
        if (msg.contains(";")) {
          parts = msg.split(";");
        } else
        if (msg.contains(",")) {
          parts = msg.split(",");
        } else {
          if (graphData.get(0).size()==0) {
            graphStartMillis = tts.millis;
          }
          try {
            PVector v = new PVector((tts.millis-graphStartMillis)/1000f,Float.parseFloat(msg));
            graphData.get(activeChart).add(v);
            if (maxXDataLength>0) {
              if (graphData.get(activeChart).size()>maxXDataLength) {
                graphData.get(activeChart).remove(0);
              }
              PVector first = graphData.get(activeChart).get(0);
              PVector last = graphData.get(activeChart).get(graphData.get(activeChart).size()-1);
              lineCharts.get(activeChart).setMinX(first.x);
              lineCharts.get(activeChart).setMaxX(last.x);
            }
          } catch(Exception e) {
            e.printStackTrace();
          }
        }
 
    } else {
      println("it's config: "+msg);
      if (msg.startsWith("title:")) {
        pageTitle = msg.substring(6);
      } else
      if (msg.startsWith("subtitle:")) {
        pageSubtitle = msg.substring(9);
      } else
      if (msg.startsWith("setMaxY:")) {
        try {
          setMaxY = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMaxY(setMaxY);
          }  
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setMinY:")) {
        try {
          setMinY = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMinY(setMinY);
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setMaxX:")) {
        try {
          setMaxX = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMaxX(setMaxX);
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setMinX:")) {
        try {
          setMinX = Float.parseFloat(msg.substring(8));
          for (int i=0;i<lineCharts.size();i++) {
            lineCharts.get(i).setMinX(setMinX);
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setYFormat:")) {
        lineCharts.get(activeChart).setYFormat(msg.substring(11));
      } else
      if (msg.startsWith("setXFormat:")) {
        lineCharts.get(activeChart).setXFormat(msg.substring(11));
      } else
      if (msg.startsWith("setXAxisLabel:")) {
        lineCharts.get(activeChart).setXAxisLabel(msg.substring(14));
      } else
      if (msg.startsWith("setYAxisLabel:")) {
        lineCharts.get(activeChart).setYAxisLabel(msg.substring(14));
      } else
      if (msg.startsWith("setLineWidth:")) {
        lineCharts.get(activeChart).setLineWidth(Float.parseFloat(msg.substring(13)));
      } else
      if (msg.startsWith("setPointColor:")) {
        String[] rgb=msg.substring(14).split(",");
        lineCharts.get(activeChart).setPointColour(color(Integer.parseInt(rgb[0]),Integer.parseInt(rgb[1]),Integer.parseInt(rgb[2])));
      } else
      if (msg.startsWith("button:")) {
        String[] parts = msg.split(":");
        Button button = new Button();
        button.code = parts[1];
        button.text = parts[2];
        String[] rgb = parts[3].split(",");
        button.col=color(Integer.parseInt(rgb[0]),Integer.parseInt(rgb[1]),Integer.parseInt(rgb[2]));
        buttons.add(button);
      } else
      if (msg.startsWith("activeGraph:")) {
        try {
          activeChart=Integer.parseInt(msg.substring(12));
          while (lineCharts.size()<activeChart+1) {
            addChartWithSettingsAndData();
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("setXDataLength:")) {
        try {
          maxXDataLength=Integer.parseInt(msg.substring(15));
        } catch (Exception e) {
          e.printStackTrace();
        }
      } else
      if (msg.startsWith("start:")) {
        arduinoStartReceived=true;
        while (graphData.size()>0) {
          graphData.remove(0);
        }
        while (lineCharts.size()>0) {
          lineCharts.remove(0);
        }
        while (buttons.size()>0) {
          buttons.remove(0);
        }
        addChartWithSettingsAndData();
      }
    }
  }
}

// Draws the chart and a title.
void draw()
{
  background(255);
  check_serial_health();
  checkArduino();
  
  textFont(chartfont,10);
  textSize(40);
  fill(0);
  stroke(0);
  if (arduinoStartReceived) {
    for (int i=0;i<lineCharts.size();i++) {
      if (i==0) {
        lineCharts.get(i).setData(graphData.get(i));
        lineCharts.get(i).updateLayout();
        lineCharts.get(i).draw(50,50,width-100,height-100);
      } else {
        lineCharts.get(i).updateLayout();
        lineCharts.get(i).setData(graphData.get(i));
        lineCharts.get(i).draw(50+lineCharts.get(0).getLeftSpacing(),
                              50+lineCharts.get(0).getTopSpacing(),
                              width-100-lineCharts.get(0).getRightSpacing()-lineCharts.get(0).getLeftSpacing(),
                              height-100-lineCharts.get(0).getBottomSpacing()-lineCharts.get(0).getTopSpacing());
      }
    }
    fill(0);
    stroke(0);
    textSize(40);
    textAlign(CENTER, CENTER);
    text(pageTitle, width/2,30);
    textSize(20);
    text(pageSubtitle, width/2,45);
    
    float alpha = millis()-lastMouseMoved;
    if (alpha<3000) {
      alpha = 255.0;
    } else {
      alpha = max(0,(4000-alpha) / 4);
    }
    alpha = 255;
    lxstart = width-250;
    bxstart = width-290;
    for (int i=0;i<buttons.size();i++) {  
      
      // rechteck legende
      fill(color(red(buttons.get(i).col),green(buttons.get(i).col),blue(buttons.get(i).col),alpha));
      strokeWeight(0);
      rect(bxstart,bystart+i*byoffset,30,30);
      
      // button
      fill(190,alpha);
      strokeWeight(2);
      //rect(bxstart,20+i*50,bwidth,30);
      
      fill(color(0,0,0,alpha));
      textSize(40);
      if (alpha>0) {
        textAlign(LEFT, CENTER);
        text(buttons.get(i).text,lxstart,bystart+i*byoffset+bheight/2);
      }
    }
  } else {
    fill(0);
    textSize(50);
    textAlign(CENTER, CENTER);
    text("Waiting for Arduino", width/2,height*0.9);
    pplogo.drawLogo(width/2-100,height/2-100,200,200);
  }
}

void keyPressed() {
  
}

long lastMouseMoved;
void mouseMoved() {
  lastMouseMoved = millis();
}


void mouseClicked() {
  // docu: https://github.com/processing/processing/blob/master/core/src/processing/core/PApplet.java
  
  //PApplet.main(new String[] { "--sketch-path="+sketchPath(), this.getClass().getSimpleName() });
  //PApplet.runSketch(new String[] {  "--sketch-path="+sketchPath(),this.getClass().getSimpleName()}, new arduino_plotter_multi());
  //dispose();
  
  for (int i=0;i<buttons.size();i++) {   
      if (mouseX>bxstart && mouseX<bxstart+bwidth) {
        if (mouseY>bystart+i*byoffset && mouseY<bystart+i*byoffset+bheight) {
          arduinoPort.write(buttons.get(i).code);  
        }
      }
    }
}